﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using Telerik.Windows.Controls;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace SilverlightApplication169
{
    public partial class MainPage : UserControl
    {

        public MainPage()
        {
            InitializeComponent();
            tree.ItemsSource = GenerateItems();
        }

        private ObservableCollection<Item> GenerateItems()
        {
            ObservableCollection<Item> result = new ObservableCollection<Item>();

            for (int i = 0; i < 20; i++)
            {
                Item item = new Item()
                {
                    DisplayHierrarchy = String.Format("{0}", i),
                    Text = String.Format("Item {0}", i)
                };

                for (int j = 0; j < 5; j++)
                {
                    Item child = new Item()
                    {
                        DisplayHierrarchy = String.Format("{0}.{1}", i, j),
                        Text = String.Format("Item {0}.{1}", i, j)
                    };

                    for (int k = 0; k < 3; k++)
                    {
                        child.Items.Add(new Item()
                    {
                        DisplayHierrarchy = String.Format("{0}.{1}.{2}", i, j, k),
                        Text = String.Format("Item {0}.{1}.{2}", i, j, k)
                    });
                    }
                    item.Items.Add(child);
                }
                result.Add(item);
            }
            return result;
        }

        private void tree_ItemPrepared(object sender, RadTreeViewItemPreparedEventArgs e)
        {
            e.PreparedItem.SizeChanged += new SizeChangedEventHandler(item_SizeChanged);
        }

        void item_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            var item = sender as RadTreeViewItem;
            var point = item.TransformToVisual(tree).Transform(new Point(0, 0));
            double newWidth = tree.ActualWidth - point.X - 30;
            item.Width = newWidth;
        }
    }

    public class Item
    {
        public Item()
        {
            Items = new ObservableCollection<Item>();
        }
        public string Text { get; set; }

        public ObservableCollection<Item> Items { get; set; }

        public string DisplayHierrarchy { get; set; }
    }
}
